{--------------------------------------------------------}
{    Conversor de formatos de som
{    Por Jos Antonio Borges
{    Em 29/05/98
{--------------------------------------------------------}

program convsons;
uses
  windows,
  dvcrt,
  dvwin,
  gramost in '..\minigrav\gramost.pas',
  comsg,
  classes,
  sysutils;

var
    nomeDir: string;
    narq: integer;
    velocidade, bitsPorAmostra, canais: integer;
    nomesArqs: TStringList;

label fim;

{--------------------------------------------------------}

function achaNumArqs (nomeDir: string): integer;
var
    buscado: TSearchRec;
    numArqs: integer;
    dosError: integer;
begin
    nomesArqs := TStringList.create;

    numArqs := 0;
    dosError := FindFirst ('*.WAV', FAARCHIVE, buscado);
    while dosError = 0 do
        begin
            nomesArqs.Add(buscado.FindData.cFileName);
            dosError := FindNext(buscado);
            numArqs := numArqs + 1;
        end;

    achaNumArqs := numArqs;
end;

{--------------------------------------------------------}

procedure inicializa;
var amb: string;
begin
    ScreenSize.y := 10;
    amb := sintAmbiente ('CONVSONS', 'DIRCONVSONS');
    if amb = '' then amb := 'c:\winvox\som\convsons';
    sintInic (0, amb);

    sintFalaPont := false;
    mensagem ('COINIC', 2);  {'Conversor de formatos de Som'}
    while sintFalando do;

    mensagem ('COINFDIR', 1);  {'Informe nome do diretrio a converter'}
    sintReadln (nomeDir);
    if nomeDir = '' then
        begin
            sintFim;
            doneWinCrt;
        end;

    {$I-} chDir (nomeDir);  {$I+}
    if ioresult <> 0 then
        begin
            mensagem ('CODIRNAO', 1); {'Diretrio inexistente'}
            delay (1000);
            sintFim;
            doneWinCrt;
        end;

    mensagem ('COVELOC', 0);  {'Velocidade final (sugiro 11025, 22050 ou 44100): '}
    sintReadint (velocidade);
    mensagem ('COBITS', 0);   {'Bits por amostra (8 ou 16): '}
    sintReadint (bitsPorAmostra);
    mensagem ('COCANAIS', 0); {'Canais (1 ou 2):'}
    sintReadint (canais);

    narq := achaNumArqs (nomeDir);

    mensagem ('CONUMARQ', 0);   {'Nmero de arquivos a converter: '}
    sintWriteln (intToStr (narq));
end;

{--------------------------------------------------------}

procedure converteArquivo (n: integer);
var nomeArq: string;
    som, som2: TAmostras;
begin
    nomeArq := nomesArqs [n];
    writeln (nomeArq);

    som := TAmostras.Create;
    som.leArquivo(nomeArq);

    som2:= TAmostras.Create;
    som2.reAmostra (som, velocidade);
    som2.bitsPorAmostra := bitsPorAmostra;
    som2.canais := canais;
    som.Free;
    som := som2;
    // som2 := NIL;

    if not som.gravaArquivo(nomeArq) then
        begin
            mensagem ('COERRGRG', 0);  {'Erro de gravao: '}
            sintWriteln (nomeArq);
            writeln;
            mensagem ('COAPTENT', 1);  {'Aperte enter'}
            readln;
        end;
end;

{--------------------------------------------------------}

procedure finaliza;
begin
    nomesArqs.Free;
    mensagem ('COOK', 1);   {'OK'}
    sintFim;
    doneWinCrt;
end;

{--------------------------------------------------------}

var i: integer;
begin
    inicializa;
    for i := 0 to narq-1 do
        converteArquivo (i);
    writeln;
    finaliza;
end.

